3 ########################################################################
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
10 # Script to create a GCC release.
12 # Copyright (c) 2001, 2002 Free Software Foundation.
14 # This file is part of GCC.
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24 # GNU General Public License for more details.
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING. If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
31 ########################################################################
33 ########################################################################
35 ########################################################################
37 # Here is an example usage of this script, to create a GCC 3.0.2
40 # gcc_release -r 3.0.2
42 # This script will automatically use the head of the release branch
43 # to generate the release.
45 ########################################################################
47 ########################################################################
49 # Issue the error message given by $1 and exit with a non-zero
53 echo "gcc_release: error: $1"
57 # Issue the informational message given by $1.
60 echo "gcc_release: $1"
63 # Issue a usage message explaining how to use this script.
67 gcc_release -r release [-f] [further options]
68 gcc_release -s name:cvsbranch [further options]
72 -r release Version of the form X.Y or X.Y.Z.
73 -s name:cvsbranch Create a snapshot, not a real release.
75 -d destination Local working directory where we will build the release
77 -f Create a final release (and update ChangeLogs,...).
78 -l Indicate that we are running on gcc.gnu.org.
79 -p previous-tarball Location of a previous tarball (to generate diff files).
80 -t tag Tag to mark the release in CVS.
81 -u username Username for upload operations.
86 # Change to the directory given by $1.
90 error
"Could not change directory to $1"
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree. Return another name for that directory, relative
95 # to the working directory.
99 echo `basename ${SOURCE_DIRECTORY}`/$x
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
107 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108 if [ -r ${WORKING_DIRECTORY} ]; then
109 error
"\`${WORKING_DIRECTORY}' already exists"
111 # Create the WORKING_DIRECTORY.
112 mkdir
"${WORKING_DIRECTORY}" \
113 || error
"Could not create \`${WORKING_DIRECTORY}'"
114 changedir
"${WORKING_DIRECTORY}"
116 # If this is a final release, make sure that the ChangeLogs
117 # and version strings are updated.
118 if [ ${FINAL} -ne 0 ]; then
119 inform
"Updating ChangeLogs and version files"
121 ${CVS} co
-d "`basename ${SOURCE_DIRECTORY}`" \
122 -r ${CVSBRANCH} gcc || \
123 error
"Could not check out release sources"
124 for x
in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125 # Update this ChangeLog file only if it does not yet contain the
126 # entry we are going to add. (This is a safety net for repeated
127 # runs of this script for the same release.)
128 if ! grep "GCC ${RELEASE} released." ${x} > /dev
/null
; then
129 cat - ${x} > ${x}.new
<<EOF
130 ${LONG_DATE} Release Manager
132 * GCC ${RELEASE} released.
135 mv ${x}.new
${x} || \
136 error
"Could not update ${x}"
137 (changedir
`dirname ${x}` && \
138 ${CVS} ci
-m 'Mark ChangeLog' `basename ${x}`) || \
139 error
"Could not commit ${x}"
143 # Update `gcc/version.c'.
144 for x
in gcc
/version.c
; do
146 (changedir
`dirname ${SOURCE_DIRECTORY}/${x}` && \
147 sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new
&& \
148 mv ${y}.new
${y} && \
149 ${CVS} ci
-m 'Update version' ${y}) || \
150 error
"Could not update ${x}"
153 # Make sure we tag the sources for a final release.
154 TAG
="gcc_`echo ${RELEASE} | tr . _`_release"
156 rm -rf ${SOURCE_DIRECTORY}
161 if [ -n "${TAG}" ]; then
162 inform
"Tagging sources as ${TAG}"
163 ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
164 error
"Could not tag sources"
167 if [ ${CVSBRANCH} != "HEAD" ]; then
168 EXPORTTAG
="-r${CVSBRANCH}"
169 # It does not work to use both "-r" and "-D" with
170 # "cvs export" so EXPORTDATE is not set here.
172 # HEAD is the default branch, no need to specify it.
174 EXPORTDATE
="-D`date -u +"%Y-
%m-
%d
%H
:%M
"` UTC"
178 # Export the current sources.
179 inform
"Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
181 if [ -z "${EXPORTTAG}" ]; then
182 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
183 "${EXPORTDATE}" gcc || \
184 error
"Could not retrieve sources"
185 elif [ -z "${EXPORTDATE}" ]; then
186 ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
187 "${EXPORTTAG}" gcc || \
188 error
"Could not retrieve sources"
190 error
"Cannot specify -r and -D at the same time"
193 # Run gcc_update on them to set up the timestamps nicely, and (re)write
194 # the LAST_UPDATED file containing the CVS tag/date used.
195 changedir
"gcc-${RELEASE}"
196 contrib
/gcc_update
--touch
197 echo "Obtained from CVS: ${EXPORTTAG} ${EXPORTDATE}" > LAST_UPDATED
199 # Obtain some documentation files from the wwwdocs module.
200 inform
"Retrieving HTML documentation"
201 changedir
"${WORKING_DIRECTORY}"
202 for x
in bugs faq
; do
203 (${CVS} export -r HEAD wwwdocs
/htdocs
/${x}.html
&& \
204 cp ${WORKING_DIRECTORY}/wwwdocs
/htdocs
/${x}.html \
205 ${SOURCE_DIRECTORY}) || \
206 error
"Could not retrieve ${x}.html"
209 inform
"Generating plain-text documentation from HTML"
210 changedir
"${SOURCE_DIRECTORY}"
211 for file in *.html
; do
212 newfile
=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
213 (${ENV} TERM
=vt100 lynx
-dump $file \
214 |
sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
216 error
"Could not generate text-only version of ${file}"
219 # For a prerelease or real release, we need to generate additional
220 # files not present in CVS.
221 changedir
"${SOURCE_DIRECTORY}"
222 if [ $SNAPSHOT -ne 1 ]; then
223 # Generate the documentation.
224 inform
"Building install docs"
225 SOURCEDIR
=${SOURCE_DIRECTORY}/gcc
/doc
226 DESTDIR
=${SOURCE_DIRECTORY}/INSTALL
229 ${SOURCE_DIRECTORY}/gcc
/doc
/install.texi2html
231 # Regenerate the NEWS file.
232 contrib
/gennews
> NEWS || \
233 error
"Could not regenerate NEWS files"
235 # Now, we must build the compiler in order to create any generated
236 # files that are supposed to go in the source directory. This is
237 # also a good sanity check to make sure that the release builds
238 # on at least one platform.
239 inform
"Building compiler"
240 OBJECT_DIRECTORY
=..
/objdir
241 contrib
/gcc_build
-d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} \
242 -c "--enable-generated-files-in-srcdir" build || \
243 error
"Could not rebuild GCC"
246 # Move message catalogs to source directory.
247 mv ..
/objdir
/gcc
/po
/*.gmo gcc
/po
/
249 # Create a "MD5SUMS" file to use for checking the validity of the release.
250 find .
-type f |
sed -e 's:^\./::' -e '/MD5SUMS/d' |
sort |
xargs md5sum >MD5SUMS
253 # Buid a single tarfile. The first argument is the name of the name
254 # of the tarfile to build, without any suffixes. They will be added
255 # automatically. The rest of the arguments are the files or
256 # directories to include.
259 # Get the name of the destination tar file.
263 # Build the tar file itself.
264 (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
265 error
"Could not build tarfile"
266 FILE_LIST
="${FILE_LIST} ${TARFILE}"
269 # Build the various tar files for the release.
272 inform
"Building tarfiles"
274 changedir
"${WORKING_DIRECTORY}"
276 # The GNU Coding Standards specify that all files should
278 chmod -R a
+r
${SOURCE_DIRECTORY}
279 # And that all directories have mode 777.
280 find ${SOURCE_DIRECTORY} -type d
-exec chmod 777 {} \
;
282 # Build one huge tarfile for the entire distribution.
283 build_tarfile gcc-
${RELEASE} `basename ${SOURCE_DIRECTORY}`
285 # Now, build one for each of the languages.
286 build_tarfile gcc-ada-
${RELEASE} ${ADA_DIRS}
287 build_tarfile gcc-g
++-${RELEASE} ${CPLUSPLUS_DIRS}
288 build_tarfile gcc-g77-
${RELEASE} ${FORTRAN_DIRS}
289 build_tarfile gcc-java-
${RELEASE} ${JAVA_DIRS}
290 build_tarfile gcc-objc-
${RELEASE} ${OBJECTIVEC_DIRS}
291 build_tarfile gcc-testsuite-
${RELEASE} ${TESTSUITE_DIRS}
293 # The core is everything else.
295 for x
in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
296 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
297 EXCLUDES
="${EXCLUDES} --exclude $x"
299 build_tarfile gcc-core-
${RELEASE} ${EXCLUDES} \
300 `basename ${SOURCE_DIRECTORY}`
305 for f
in ${FILE_LIST}; do
307 (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
311 # Build diffs against an old release.
315 old_vers=${old_file%.tar.bz2}
316 old_vers=${old_vers#gcc-}
317 inform "Building diffs against version
$old_vers"
318 for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
319 old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
320 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
321 if [ ! -e $old_tar ]; then
322 inform "$old_tar not found
; not generating
diff file"
323 elif [ ! -e $new_tar ]; then
324 inform "$new_tar not found
; not generating
diff file"
326 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
327 ${f}-${old_vers}-${RELEASE}.diff.bz2
332 # Build an individual diff.
334 changedir "${WORKING_DIRECTORY}"
336 mkdir $tmpdir || error "Could not create directory
$tmpdir"
338 (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack
$1 for diffs
"
339 (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack
$3 for diffs
"
340 ${DIFF} $2 $4 > ../${5%.bz2}
341 if [ $? -eq 2 ]; then
342 error "Trouble making diffs from
$1 to
$3"
344 ${BZIP2} ../${5%.bz2} || error "Could not generate ..
/$5"
347 FILE_LIST="${FILE_LIST} $5"
350 # Upload the files to the FTP server.
352 inform "Uploading files
"
354 changedir "${WORKING_DIRECTORY}"
356 # Make sure the directory exists on the server.
357 if [ $LOCAL -eq 0 ]; then
358 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
359 mkdir -p "${FTP_PATH}/diffs
"
360 UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
362 mkdir -p "${FTP_PATH}/diffs
" \
363 || error "Could not create \
`${FTP_PATH}'"
364 UPLOAD_PATH=${FTP_PATH}
367 # Then copy files to their respective (sub)directories.
368 for x in gcc*.gz gcc*.bz2; do
370 # Make sure the file will be readable on the server.
380 ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
381 || error "Could not upload ${x}"
386 # Announce a snapshot, both on the web and via mail.
387 announce_snapshot() {
388 inform "Updating links and READMEs on the FTP server"
390 TEXT_DATE=`date --date=$DATE +%B\
%d
,\
%Y
`
391 changedir ~ftp/pub/gcc/snapshots
392 sed -e "s%@DATE@%$DATE%g" \
393 -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
394 -e "s%@LAST_DATE@%$LAST_DATE%g" \
395 -e "s%@BRANCH@%${BRANCH}%g" \
396 -e "s%@RELEASE@%${RELEASE}%g" \
397 -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
398 ~/scripts/snapshot-README > $$
399 mv $$ ${RELEASE}/README
400 sed -e "s%@DATE@%$DATE%g" \
401 -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
402 -e "s%@LAST_DATE@%$LAST_DATE%g" \
403 -e "s%@BRANCH@%${BRANCH}%g" \
404 -e "s%@RELEASE@%${RELEASE}%g" \
405 -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
406 ~/scripts/snapshot-index.html > $$
407 mv $$ ${RELEASE}/index.html
409 touch LATEST-IS-${BRANCH}-${DATE}
410 rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
412 inform "Sending mail"
414 export QMAILHOST=gcc.gnu.org
415 mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/${RELEASE}/README
418 ########################################################################
420 ########################################################################
423 DATE=`date "+%Y%m%d"`
424 LONG_DATE=`date "+%Y-%m-%d"`
426 # The CVS server containing the GCC repository.
427 CVS_SERVER="gcc.gnu.org"
428 # The path to the repository on that server.
429 CVS_REPOSITORY="/cvs/gcc"
430 # The CVS protocol to use.
432 # The username to use when connecting to the server.
433 CVS_USERNAME="${USER}"
435 # The machine to which files will be uploaded.
436 GCC_HOSTNAME="gcc.gnu.org"
437 # The name of the account on the machine to which files are uploaded.
438 GCC_USERNAME="gccadmin"
439 # The directory in which the files will be placed.
440 FTP_PATH="~ftp/pub/gcc"
442 # The major number for the release. For release `3.0.2' this would be
445 # The minor number for the release. For release `3.0.2' this would be
448 # The revision number for the release. For release `3.0.2' this would
451 # The complete name of the release.
454 # The name of the branch from which the release should be made, in a
455 # user-friendly form.
458 # The name of the branch from which the release should be made, as used
459 # for our version control system.
462 # The tag to apply to the sources used for the release.
465 # The old tarballs from which to generate diffs.
468 # The directory that will be used to construct the release. The
469 # release itself will be placed in a subdirectory of this diretory.
473 # The directory that will contain the GCC sources.
476 # The directories that should be part of the various language-specific
477 # tar files. These are all relative to the top of the source tree.
479 CPLUSPLUS_DIRS
="gcc/cp libstdc++-v3"
480 FORTRAN_DIRS
="gcc/f libf2c"
481 JAVA_DIRS
="gcc/java libjava libffi fastjar zlib boehm-gc"
482 OBJECTIVEC_DIRS
="gcc/objc libobjc"
483 TESTSUITE_DIRS
="gcc/testsuite"
485 # Non-zero if this is the final release, rather than a prerelease.
488 # Non-zero if we are building a snapshot, and don't build gcc or
489 # include generated files.
492 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
493 # and copy directly to the FTP directory.
496 # Major operation modes.
503 # List of archive files generated; used to create .gz files from .bz2.
508 BZIP2
="${BZIP2:-bzip2}"
509 CVS
="${CVS:-cvs -f -Q -z9}"
510 DIFF
="${DIFF:-diff -Nrc3pad}"
512 GZIP
="${GZIP:-gzip --best}"
517 ########################################################################
518 # Command Line Processing
519 ########################################################################
522 while getopts "d:fr:u:t:p:s:l" ARG
; do
524 d
) DESTINATION
="${OPTARG}";;
525 r
) RELEASE
="${OPTARG}";;
527 u
) CVS_USERNAME
="${OPTARG}";;
531 CVSBRANCH
=${OPTARG#*:}
535 FTP_PATH
=~ftp
/pub
/gcc
536 PATH
=~
:/usr
/local
/bin
:$PATH;;
537 p
) OLD_TARS
="${OLD_TARS} ${OPTARG}"
538 if [ -d ${OPTARG} ]; then
539 error
"-p argument must name a tarball"
544 shift `expr ${OPTIND} - 1`
546 # Handle the major modes.
547 while [ $# -ne 0 ]; do
549 diffs
) MODE_DIFFS
=1;;
551 sources
) MODE_SOURCES
=1;;
552 tarfiles
) MODE_TARFILES
=1;;
553 upload
) MODE_UPLOAD
=1;;
554 all
) MODE_SOURCES
=1; MODE_TARFILES
=1; MODE_DIFFS
=1; MODE_UPLOAD
=1;
555 if [ $SNAPSHOT -ne 1 ]; then
556 # Only for releases and pre-releases.
560 *) error
"Unknown mode $1";;
565 # Perform consistency checking.
566 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
567 error
"No username specified"
570 if [ ! -d ${DESTINATION} ]; then
571 error
"\`${DESTINATION}' is not a directory"
574 if [ $SNAPSHOT -eq 0 ]; then
575 if [ -z ${RELEASE} ]; then
576 error
"No release number specified"
579 # Compute the major and minor release numbers.
580 RELEASE_MAJOR
=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
581 RELEASE_MINOR
=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
582 RELEASE_REVISION
=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
584 if [ -z "${RELEASE_MAJOR}" ] ||
[ -z "${RELEASE_MINOR}" ]; then
585 error
"Release number \`${RELEASE}' is invalid"
588 # Compute the full name of the release.
589 if [ -z "${RELEASE_REVISION}" ]; then
590 RELEASE
="${RELEASE_MAJOR}.${RELEASE_MINOR}"
592 RELEASE
="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
595 # Compute the name of the branch, which is based solely on the major
596 # and minor release numbers.
597 CVSBRANCH
="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
599 # If this is not a final release, set various parameters acordingly.
600 if [ ${FINAL} -ne 1 ]; then
601 RELEASE
="${RELEASE}-${DATE}"
602 FTP_PATH
="${FTP_PATH}/prerelease-${RELEASE}/"
604 FTP_PATH
="${FTP_PATH}/releases/gcc-${RELEASE}/"
607 RELEASE
=${BRANCH}-${DATE}
608 FTP_PATH
="${FTP_PATH}/snapshots/${RELEASE}"
609 if [ ${CVSBRANCH} != "HEAD" ]; then
610 TAG
=gcc-ss-
`echo ${RELEASE} | tr '.' '_'`
613 # Building locally on gcc.gnu.org, we know what the last snapshot date
615 if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ]; then
616 LAST_DATE
=`cat ~/.snapshot_date-${BRANCH}`
617 LAST_DIR
=~ftp
/pub
/gcc
/snapshots
/${BRANCH}-${LAST_DATE}
618 OLD_TARS
=${LAST_DIR}/gcc-${BRANCH}-${LAST_DATE}.
tar.bz2
622 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
623 WORKING_DIRECTORY
="${DESTINATION}/gcc-${RELEASE}"
624 SOURCE_DIRECTORY
="${WORKING_DIRECTORY}/gcc-${RELEASE}"
626 # Recompute the names of all the language-specific directories,
627 # relative to the WORKING_DIRECTORY.
628 ADA_DIRS
=`adjust_dirs ${ADA_DIRS}`
629 CPLUSPLUS_DIRS
=`adjust_dirs ${CPLUSPLUS_DIRS}`
630 FORTRAN_DIRS
=`adjust_dirs ${FORTRAN_DIRS}`
631 JAVA_DIRS
=`adjust_dirs ${JAVA_DIRS}`
632 OBJECTIVEC_DIRS
=`adjust_dirs ${OBJECTIVEC_DIRS}`
633 TESTSUITE_DIRS
=`adjust_dirs ${TESTSUITE_DIRS}`
636 if [ $LOCAL -eq 0 ]; then
637 CVSROOT
=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
638 CVSROOT
="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
640 CVSROOT
="${CVS_REPOSITORY}"
644 ########################################################################
646 ########################################################################
648 # Set the timezone to UTC
652 # Build the source directory.
654 if [ $MODE_SOURCES -ne 0 ]; then
658 # Build the tar files.
660 if [ $MODE_TARFILES -ne 0 ]; then
666 if [ $MODE_DIFFS -ne 0 ]; then
667 # Possibly build diffs.
668 if [ -n "$OLD_TARS" ]; then
669 for old_tar
in $OLD_TARS; do
676 if [ $MODE_GZIP -ne 0 ]; then
680 # Upload them to the FTP server.
682 if [ $MODE_UPLOAD -ne 0 ]; then
685 # For snapshots, make some further updates.
686 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
689 # Update snapshot date file.
691 echo $DATE > .snapshot_date-
${BRANCH}
693 # Remove working directory
694 rm -rf ${WORKING_DIRECTORY}